(* This file is generated by Why3's Coq driver *)
(* Beware! Only edit allowed sections below    *)
Require Import BuiltIn.
Require BuiltIn.
Require int.Int.
Require map.Map.

(* Why3 assumption *)
Definition unit := unit.

(* Why3 assumption *)
Inductive list
  (a:Type) {a_WT:WhyType a} :=
  | Nil : list a
  | Cons : a -> (list a) -> list a.
Axiom list_WhyType : forall (a:Type) {a_WT:WhyType a}, WhyType (list a).
Existing Instance list_WhyType.
Implicit Arguments Nil [[a] [a_WT]].
Implicit Arguments Cons [[a] [a_WT]].

Parameter head: forall {a:Type} {a_WT:WhyType a}, (list a) -> a.

Axiom head_cons : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (l:(list
  a)), ((head (Cons x l)) = x).

Parameter tail: forall {a:Type} {a_WT:WhyType a}, (list a) -> (list a).

Axiom tail_cons : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (l:(list
  a)), ((tail (Cons x l)) = l).

(* Why3 assumption *)
Fixpoint append {a:Type} {a_WT:WhyType a} (l1:(list a)) (l2:(list
  a)) {struct l1}: (list a) :=
  match l1 with
  | Nil => l2
  | (Cons x l) => (Cons x (append l l2))
  end.

Axiom append_nil : forall {a:Type} {a_WT:WhyType a}, forall (l:(list a)),
  ((append l (Nil :(list a))) = l).

Axiom append_assoc : forall {a:Type} {a_WT:WhyType a}, forall (l1:(list a))
  (l2:(list a)) (l3:(list a)), ((append (append l1 l2) l3) = (append l1
  (append l2 l3))).

(* Why3 assumption *)
Fixpoint length {a:Type} {a_WT:WhyType a} (l:(list a)) {struct l}: Z :=
  match l with
  | Nil => 0%Z
  | (Cons x r) => (1%Z + (length r))%Z
  end.

Axiom length_nonneg : forall {a:Type} {a_WT:WhyType a}, forall (l:(list a)),
  (0%Z <= (length l))%Z.

(* Why3 assumption *)
Fixpoint mem {a:Type} {a_WT:WhyType a} (x:a) (l:(list a)) {struct l}: Prop :=
  match l with
  | Nil => False
  | (Cons y r) => (x = y) \/ (mem x r)
  end.

Axiom mem_append : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (l1:(list
  a)) (l2:(list a)), (mem x (append l1 l2)) <-> ((mem x l1) \/ (mem x l2)).

(* Why3 assumption *)
Definition disjoint {a:Type} {a_WT:WhyType a} (l1:(list a)) (l2:(list
  a)): Prop := forall (x:a), ~ ((mem x l1) /\ (mem x l2)).

(* Why3 assumption *)
Fixpoint no_repet {a:Type} {a_WT:WhyType a} (l:(list a)) {struct l}: Prop :=
  match l with
  | Nil => True
  | (Cons x r) => (~ (mem x r)) /\ (no_repet r)
  end.

(* Why3 assumption *)
Inductive ref (a:Type) {a_WT:WhyType a} :=
  | mk_ref : a -> ref a.
Axiom ref_WhyType : forall (a:Type) {a_WT:WhyType a}, WhyType (ref a).
Existing Instance ref_WhyType.
Implicit Arguments mk_ref [[a] [a_WT]].

(* Why3 assumption *)
Definition contents {a:Type} {a_WT:WhyType a} (v:(ref a)): a :=
  match v with
  | (mk_ref x) => x
  end.

Axiom loc : Type.
Parameter loc_WhyType : WhyType loc.
Existing Instance loc_WhyType.

Parameter null: loc.

(* Why3 assumption *)
Inductive list_seg : loc -> (map.Map.map loc loc) -> (list loc)
  -> loc -> Prop :=
  | list_seg_nil : forall (p:loc) (next:(map.Map.map loc loc)), (list_seg p
      next (Nil :(list loc)) p)
  | list_seg_cons : forall (p:loc) (q:loc) (next:(map.Map.map loc loc))
      (l:(list loc)), ((~ (p = null)) /\ (list_seg (map.Map.get next p) next
      l q)) -> (list_seg p next (Cons p l) q).

Axiom list_seg_extend_last : forall (next:(map.Map.map loc loc)) (p:loc)
  (q:loc) (pM:(list loc)), ((list_seg p next pM q) /\ ~ (q = null)) ->
  (list_seg p next (append pM (Cons q (Nil :(list loc)))) (map.Map.get next
  q)).

Axiom list_seg_frame_ext : forall (next1:(map.Map.map loc loc))
  (next2:(map.Map.map loc loc)) (p:loc) (q:loc) (r:loc) (v:loc) (pM:(list
  loc)), ((list_seg p next1 pM r) /\ ((next2 = (map.Map.set next1 q v)) /\
  ~ (mem q pM))) -> (list_seg p next2 pM r).

Axiom list_seg_no_repet : forall (next:(map.Map.map loc loc)) (p:loc)
  (pM:(list loc)), (list_seg p next pM null) -> (no_repet pM).

Axiom list_seg_append : forall (next:(map.Map.map loc loc)) (p:loc) (q:loc)
  (r:loc) (pM:(list loc)) (qM:(list loc)), ((list_seg p next pM q) /\
  ((~ (q = null)) /\ (list_seg q next qM r))) -> (list_seg p next (append pM
  qM) r).

Require Import Why3.

(* Why3 goal *)
Theorem WP_parameter_app : forall (l1:loc) (l2:loc) (l1M:(list loc))
  (l2M:(list loc)), forall (next:(map.Map.map loc loc)), (((list_seg l1 next
  l1M null) /\ (list_seg l2 next l2M null)) /\ (disjoint l1M l2M)) ->
  ((~ (l1 = null)) -> forall (l1pM:(list loc)) (pM:(list loc)) (p:loc),
  ((((((((~ (p = null)) /\ (list_seg l2 next l2M null)) /\ (list_seg l1 next
  l1pM p)) /\ (list_seg p next pM null)) /\ ((append l1pM pM) = l1M)) /\
  (disjoint l1pM pM)) /\ (disjoint l1pM l2M)) /\ ~ (mem p l1pM)) ->
  ((~ (p = null)) -> (((map.Map.get next p) = null) -> ((pM = (Cons p
  (Nil :(list loc)))) -> ((~ (p = null)) -> forall (next1:(map.Map.map loc
  loc)), (next1 = (map.Map.set next p l2)) -> ((list_seg p next1 (Cons p l2M)
  null) -> (list_seg l1 next1 (append l1M l2M) null))))))).
intros l1 l2 l1M l2M next ((h1,h2),h3) h4 l1pM pM p
(((((((h5,h6),h7),h8),h9),h10),h11),h12) h13 h14 h15 h16 next1 h17 h18.
apply list_seg_append with (q:= p).
split.
2: why3 "alt-ergo" timelimit 5.
Qed.


