(* This file is generated by Why3's Coq driver *)
(* Beware! Only edit allowed sections below    *)
Require Import BuiltIn.
Require BuiltIn.
Require int.Int.
Require map.Map.

(* Why3 assumption *)
Definition unit := unit.

(* Why3 assumption *)
Inductive list
  (a:Type) {a_WT:WhyType a} :=
  | Nil : list a
  | Cons : a -> (list a) -> list a.
Axiom list_WhyType : forall (a:Type) {a_WT:WhyType a}, WhyType (list a).
Existing Instance list_WhyType.
Implicit Arguments Nil [[a] [a_WT]].
Implicit Arguments Cons [[a] [a_WT]].

Parameter head: forall {a:Type} {a_WT:WhyType a}, (list a) -> a.

Axiom head_cons : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (l:(list
  a)), ((head (Cons x l)) = x).

Parameter tail: forall {a:Type} {a_WT:WhyType a}, (list a) -> (list a).

Axiom tail_cons : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (l:(list
  a)), ((tail (Cons x l)) = l).

(* Why3 assumption *)
Fixpoint append {a:Type} {a_WT:WhyType a} (l1:(list a)) (l2:(list
  a)) {struct l1}: (list a) :=
  match l1 with
  | Nil => l2
  | (Cons x l) => (Cons x (append l l2))
  end.

Axiom append_nil : forall {a:Type} {a_WT:WhyType a}, forall (l:(list a)),
  ((append l (Nil :(list a))) = l).

Axiom append_assoc : forall {a:Type} {a_WT:WhyType a}, forall (l1:(list a))
  (l2:(list a)) (l3:(list a)), ((append (append l1 l2) l3) = (append l1
  (append l2 l3))).

(* Why3 assumption *)
Fixpoint length {a:Type} {a_WT:WhyType a} (l:(list a)) {struct l}: Z :=
  match l with
  | Nil => 0%Z
  | (Cons x r) => (1%Z + (length r))%Z
  end.

Axiom length_nonneg : forall {a:Type} {a_WT:WhyType a}, forall (l:(list a)),
  (0%Z <= (length l))%Z.

(* Why3 assumption *)
Fixpoint mem {a:Type} {a_WT:WhyType a} (x:a) (l:(list a)) {struct l}: Prop :=
  match l with
  | Nil => False
  | (Cons y r) => (x = y) \/ (mem x r)
  end.

Axiom mem_append : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (l1:(list
  a)) (l2:(list a)), (mem x (append l1 l2)) <-> ((mem x l1) \/ (mem x l2)).

(* Why3 assumption *)
Definition disjoint {a:Type} {a_WT:WhyType a} (l1:(list a)) (l2:(list
  a)): Prop := forall (x:a), ~ ((mem x l1) /\ (mem x l2)).

(* Why3 assumption *)
Fixpoint no_repet {a:Type} {a_WT:WhyType a} (l:(list a)) {struct l}: Prop :=
  match l with
  | Nil => True
  | (Cons x r) => (~ (mem x r)) /\ (no_repet r)
  end.

(* Why3 assumption *)
Inductive ref (a:Type) {a_WT:WhyType a} :=
  | mk_ref : a -> ref a.
Axiom ref_WhyType : forall (a:Type) {a_WT:WhyType a}, WhyType (ref a).
Existing Instance ref_WhyType.
Implicit Arguments mk_ref [[a] [a_WT]].

(* Why3 assumption *)
Definition contents {a:Type} {a_WT:WhyType a} (v:(ref a)): a :=
  match v with
  | (mk_ref x) => x
  end.

Axiom loc : Type.
Parameter loc_WhyType : WhyType loc.
Existing Instance loc_WhyType.

Parameter null: loc.

(* Why3 assumption *)
Inductive list_seg : loc -> (map.Map.map loc loc) -> (list loc)
  -> loc -> Prop :=
  | list_seg_nil : forall (p:loc) (next:(map.Map.map loc loc)), (list_seg p
      next (Nil :(list loc)) p)
  | list_seg_cons : forall (p:loc) (q:loc) (next:(map.Map.map loc loc))
      (l:(list loc)), ((~ (p = null)) /\ (list_seg (map.Map.get next p) next
      l q)) -> (list_seg p next (Cons p l) q).

Inductive list_seg2 (next:map.Map.map loc loc) (q:loc) :
  loc -> (list loc) -> Prop :=
  | list_seg2_nil : list_seg2 next q q (Nil :(list loc))
  | list_seg2_cons : forall (p:loc) (l:(list loc)), 
     ((~ (p = null)) /\ (list_seg2 next q (map.Map.get next p) l)) 
      -> (list_seg2 next q p (Cons p l)).

Lemma equiv:
  forall  (p q:loc) (l:list loc) (next: map.Map.map loc loc),
    list_seg p next l q -> list_seg2 next q p l.
induction 1.
constructor.
constructor.

(* Why3 goal *)
Theorem list_seg_extend_last : forall (next:(map.Map.map loc loc)) (p:loc)
  (q:loc) (pM:(list loc)), ((list_seg p next pM q) /\ ~ (q = null)) ->
  (list_seg p next (append pM (Cons q (Nil :(list loc)))) (map.Map.get next
  q)).
intros next p q pM (h1,h2).
generalize p pM h1.
clear p pM h1.
induction 1.
simpl.
apply list_seg_cons.
split.
auto.
apply list_seg_nil.
simpl.
destruct H.
split.
auto.
simpl.
Qed.


