(* This file is generated by Why3's Coq driver *)
(* Beware! Only edit allowed sections below    *)
Require Import BuiltIn.
Require BuiltIn.
Require int.Int.
Require map.Map.

(* Why3 assumption *)
Definition unit := unit.

(* Why3 assumption *)
Inductive list
  (a:Type) {a_WT:WhyType a} :=
  | Nil : list a
  | Cons : a -> (list a) -> list a.
Axiom list_WhyType : forall (a:Type) {a_WT:WhyType a}, WhyType (list a).
Existing Instance list_WhyType.
Implicit Arguments Nil [[a] [a_WT]].
Implicit Arguments Cons [[a] [a_WT]].

Parameter head: forall {a:Type} {a_WT:WhyType a}, (list a) -> a.

Axiom head_cons : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (l:(list
  a)), ((head (Cons x l)) = x).

Parameter tail: forall {a:Type} {a_WT:WhyType a}, (list a) -> (list a).

Axiom tail_cons : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (l:(list
  a)), ((tail (Cons x l)) = l).

(* Why3 assumption *)
Fixpoint append {a:Type} {a_WT:WhyType a} (l1:(list a)) (l2:(list
  a)) {struct l1}: (list a) :=
  match l1 with
  | Nil => l2
  | (Cons x l) => (Cons x (append l l2))
  end.

Axiom append_nil : forall {a:Type} {a_WT:WhyType a}, forall (l:(list a)),
  ((append l (Nil :(list a))) = l).

Axiom append_assoc : forall {a:Type} {a_WT:WhyType a}, forall (l1:(list a))
  (l2:(list a)) (l3:(list a)), ((append (append l1 l2) l3) = (append l1
  (append l2 l3))).

(* Why3 assumption *)
Fixpoint length {a:Type} {a_WT:WhyType a} (l:(list a)) {struct l}: Z :=
  match l with
  | Nil => 0%Z
  | (Cons x r) => (1%Z + (length r))%Z
  end.

Axiom length_nonneg : forall {a:Type} {a_WT:WhyType a}, forall (l:(list a)),
  (0%Z <= (length l))%Z.

(* Why3 assumption *)
Fixpoint mem {a:Type} {a_WT:WhyType a} (x:a) (l:(list a)) {struct l}: Prop :=
  match l with
  | Nil => False
  | (Cons y r) => (x = y) \/ (mem x r)
  end.

Axiom mem_append : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (l1:(list
  a)) (l2:(list a)), (mem x (append l1 l2)) <-> ((mem x l1) \/ (mem x l2)).

(* Why3 assumption *)
Definition disjoint {a:Type} {a_WT:WhyType a} (l1:(list a)) (l2:(list
  a)): Prop := forall (x:a), ~ ((mem x l1) /\ (mem x l2)).

(* Why3 assumption *)
Fixpoint no_repet {a:Type} {a_WT:WhyType a} (l:(list a)) {struct l}: Prop :=
  match l with
  | Nil => True
  | (Cons x r) => (~ (mem x r)) /\ (no_repet r)
  end.

(* Why3 assumption *)
Inductive ref (a:Type) {a_WT:WhyType a} :=
  | mk_ref : a -> ref a.
Axiom ref_WhyType : forall (a:Type) {a_WT:WhyType a}, WhyType (ref a).
Existing Instance ref_WhyType.
Implicit Arguments mk_ref [[a] [a_WT]].

(* Why3 assumption *)
Definition contents {a:Type} {a_WT:WhyType a} (v:(ref a)): a :=
  match v with
  | (mk_ref x) => x
  end.

Axiom loc : Type.
Parameter loc_WhyType : WhyType loc.
Existing Instance loc_WhyType.

Parameter null: loc.

(* Why3 assumption *)
Inductive list_seg : loc -> (map.Map.map loc loc) -> (list loc)
  -> loc -> Prop :=
  | list_seg_nil : forall (p:loc) (next:(map.Map.map loc loc)), (list_seg p
      next (Nil :(list loc)) p)
  | list_seg_cons : forall (p:loc) (q:loc) (next:(map.Map.map loc loc))
      (l:(list loc)), ((~ (p = null)) /\ (list_seg (map.Map.get next p) next
      l q)) -> (list_seg p next (Cons p l) q).

(* Why3 goal *)
Theorem list_seg_frame_ext : forall (next1:(map.Map.map loc loc))
  (next2:(map.Map.map loc loc)) (p:loc) (q:loc) (r:loc) (v:loc) (pM:(list
  loc)), ((list_seg p next1 pM r) /\ ((next2 = (map.Map.set next1 q v)) /\
  ~ (mem q pM))) -> (list_seg p next2 pM r).
intros until pM.
generalize p; clear p.
elim pM.
(* case pM = Nil *)
intros p (h1&h2&h3).
inversion h1; subst; clear h1.
constructor.
(* case pM = Cons a l *)
intros a l Hind p (h1&h2&h3).
inversion h1; subst; clear h1.
destruct H4.
constructor; split; auto.
simpl in h3.
rewrite Map.Select_neq; auto.
apply Hind; split; auto.
Qed.


